<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>User Detail</title>
</head>

<body>
    <div class="container jumbotron">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3>USER DETAIL</h3>
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Name</label>
            <div class="col-sm-10">
                <input id="inp-name" class="form-control" placeholder="Name ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Username</label>
            <div class="col-sm-10">
                <input id="inp-username" class="form-control" placeholder="Username ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Email</label>
            <div class="col-sm-10">
                <input id="inp-email" class="form-control" placeholder="Email ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Street</label>
            <div class="col-sm-4">
                <input id="inp-street" class="form-control" placeholder="Street ...">
            </div>
            <label class="col-sm-2 col-form-label">Suite</label>
            <div class="col-sm-4">
                <input id="inp-suite" class="form-control" placeholder="Suite ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">City</label>
            <div class="col-sm-4">
                <input id="inp-city" class="form-control" placeholder="City ...">
            </div>
            <label class="col-sm-2 col-form-label">Zip Code</label>
            <div class="col-sm-4">
                <input id="inp-zipcode" class="form-control" placeholder="Zip Code ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Latitude</label>
            <div class="col-sm-4">
                <input id="inp-latitude" class="form-control" placeholder="Latitude ...">
            </div>
            <label class="col-sm-2 col-form-label">Longitude</label>
            <div class="col-sm-4">
                <input id="inp-longitude" class="form-control" placeholder="Longitude ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Phone</label>
            <div class="col-sm-4">
                <input id="inp-phone" class="form-control" placeholder="Phone ...">
            </div>
            <label class="col-sm-2 col-form-label">Website</label>
            <div class="col-sm-4">
                <input id="inp-website" class="form-control" placeholder="Website ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Company Name</label>
            <div class="col-sm-10">
                <input id="inp-company-name" class="form-control" placeholder="Company Name ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Company Slogan</label>
            <div class="col-sm-10">
                <input id="inp-company-slogan" class="form-control" placeholder="Company Slogan ...">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Company BS</label>
            <div class="col-sm-10">
                <input id="inp-company-bs" class="form-control" placeholder="Company BS ...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12 form-group text-center">
                <button id="btn-update" class="btn btn-success">Update</button>
                <a href="userList.html" class="btn btn-danger">Cancel</a>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gUserId = "";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện load trang
    $(document).ready(onPageLoading);
    // gán sự kiện click button Update
    $("#btn-update").click(onBtnUpdateClick);
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // B1: Thu thập dữ liệu
        getUserID();
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkUserID(gUserId);
        if (vDataValid) {
            // B3: Gọi API lấy user detail bằng ID
            let vAjaxRequest = apiGetUserDetailByID(gUserId);
            vAjaxRequest.done(function(vResponse) {
                // B4: Xử lý hiển thị
                displayUserDetail(vResponse);
            })
        }
    }

    // function xử lý sự kiện click button Update
    function onBtnUpdateClick() {
        console.log("%cBUTTON UPDATE - CLICK", "color: green")
        // Khai báo đối tượng chứa dữ liệu
        let vUserData = {
            id: gUserId,
            name: "",
            username: "",
            email: "",
            address: {
                street: "",
                suite: "",
                city: "",
                zipcode: "",
                geo: {
                    lat: "",
                    lng: ""
                }
            },
            phone: "",
            website: "",
            company: {
                name: "",
                catchPhrase: "",
                bs: ""
            }
        };
        // B1: Thu thập dữ liệu
        getUserData(vUserData);
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkUserData(vUserData);
        console.log("Data Validation: " + vDataValid);
        if (vDataValid) {
            // B3: Gọi API update thông tin user
            let vAjaxRequest = apiUpdateUserDetail(vUserData);
            vAjaxRequest.done(function(vResponse) {
                // B4: Xử lý hiển thị
                console.log("Update User Response Object:");
                console.log(vResponse);
                alert("Successful update user detail");
                // quay lại trang user list khi người dùng bấm OK
                window.location.href = "userList.html";
            })
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function thu thập dữ liệu user ID
    function getUserID() {
        let vUrl = new URL(window.location.href);
        gUserId = vUrl.searchParams.get("id");
        console.log("User ID: " + gUserId);
    }

    // function kiểm tra user ID
    function checkUserID(paramUserId) {
        if (paramUserId === "") {
            alert("User ID not exist");
            return false;
        }
        return true;
    }

    // function gọi API lấy user detail bằng ID
    function apiGetUserDetailByID(paramUserId) {
        let vAjaxRequest = $.ajax({
            url: gBASE_URL + "/" + paramUserId,
            type: "GET"
        });
        return vAjaxRequest;
    }

    // function gọi API update user detail bằng ID    
    function apiUpdateUserDetail(paramUserData) {
        let vStringJson = JSON.stringify(paramUserData);
        let vAjaxRequest = $.ajax({
            url: gBASE_URL + gUserId,
            type: "PUT",
            contentType: "application/json",
            data: vStringJson,
        });
        return vAjaxRequest;
    }

    // function hiển thị thông tin user detail lên form
    function displayUserDetail(paramUserData) {
        $("#inp-name").val(paramUserData.name);
        $("#inp-username").val(paramUserData.username);
        $("#inp-email").val(paramUserData.email);
        $("#inp-street").val(paramUserData.address.street);
        $("#inp-suite").val(paramUserData.address.suite);
        $("#inp-city").val(paramUserData.address.city);
        $("#inp-zipcode").val(paramUserData.address.zipcode);
        $("#inp-latitude").val(paramUserData.address.geo.lat);
        $("#inp-longitude").val(paramUserData.address.geo.lng);
        $("#inp-phone").val(paramUserData.phone);
        $("#inp-website").val(paramUserData.website);
        $("#inp-company-name").val(paramUserData.company.name);
        $("#inp-company-slogan").val(paramUserData.company.catchPhrase);
        $("#inp-company-bs").val(paramUserData.company.bs);
    }

    // function thu thập dữ liệu trên form
    // input: tham số đối tượng paramUserData để chứa dữ liệu
    // output: paramUserData được tham số hóa
    function getUserData(paramUserData) {
        paramUserData.name = $("#inp-name").val().trim();
        paramUserData.username = $("#inp-username").val().trim();
        paramUserData.email = $("#inp-email").val().trim();
        paramUserData.address.street = $("#inp-street").val().trim();
        paramUserData.address.suite = $("#inp-suite").val().trim();
        paramUserData.address.city = $("#inp-city").val().trim();
        paramUserData.address.zipcode = $("#inp-zipcode").val().trim();
        paramUserData.address.geo.lat = $("#inp-latitude").val().trim();
        paramUserData.address.geo.lng = $("#inp-longitude").val().trim();
        paramUserData.phone = $("#inp-phone").val().trim();
        paramUserData.website = $("#inp-website").val().trim();
        paramUserData.company.name = $("#inp-company-name").val().trim();
        paramUserData.company.catchPhrase = $("#inp-company-slogan").val().trim();
        paramUserData.company.bs = $("#inp-company-bs").val().trim();
    }

    // function kiểm tra dữ liệu form
    // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
    function checkUserData(paramUserData) {
        if (paramUserData.name === "") {
            alert("Please enter Name");
            return false;
        }
        else if (paramUserData.username === "") {
            alert("Please enter Username");
            return false;
        }
        else if (paramUserData.email === "") {
            alert("Please enter Email");
            return false;
        }
        else if (paramUserData.address.street === "") {
            alert("Please enter Street");
            return false;
        }
        else if (paramUserData.address.suite === "") {
            alert("Please enter Suite");
            return false;
        }
        else if (paramUserData.address.city === "") {
            alert("Please enter City");
            return false;
        }
        else if (paramUserData.address.zipcode === "") {
            alert("Please enter Zip code");
            return false;
        }
        else if (paramUserData.address.lat === "") {
            alert("Please enter Latitude");
            return false;
        }
        else if (paramUserData.address.lng === "") {
            alert("Please enter Longitude");
            return false;
        }
        else if (paramUserData.phone === "") {
            alert("Please enter Phone");
            return false;
        }
        else if (paramUserData.website === "") {
            alert("Please enter Website");
            return false;
        }
        else if (paramUserData.company.name === "") {
            alert("Please enter Company name");
            return false;
        }
        else if (paramUserData.company.catchPhrase === "") {
            alert("Please enter Company slogan");
            return false;
        }
        else if (paramUserData.company.bs === "") {
            alert("Please enter Company BS");
            return false;
        }
        return true;
    }


</script>

</html>